#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property show_inputs

extern int     Per0 = 1;
extern int     Per1 = 2;
extern int     Per2 = 3;
extern int     P = PERIOD_D1;
//extern double  lot = 0.01;
//extern int     sl = 80;
//extern int tp = 80;
//extern int Mag = 1;
extern string  FileName = "";

int start()
{
int handle;


handle=FileOpen(FileName + ".txt", FILE_CSV|FILE_WRITE,';');
if(handle<1)
{
  Print(" : ", GetLastError());
  return(false);
}
FileWrite(handle,
          "Time",
          "Candle1",
          "Candle2", 
          "׸ "
         
          );
int p1, p2,p3,p4, sum = 0, k=0;
double perc;
for(int i = Bars-1; i >= 0; i--)
{
  p1=CandleCode(i);
  p2=CandleCode(i-1);
  for(int j = i-1; j >= 0; j--)
  {
      p3=CandleCode(j);
      p4=CandleCode(j-1);
      if(p1 == p3) k++;
      if(p1 == p3 && p2 == p4) sum+=sum;
   }
   perc=k/100*sum;
   }
for(i = Bars-1; i >= 0; i--)
{
  FileWrite(handle,
           TimeToStr(Time[i], TIME_DATE|TIME_MINUTES),
           CandleCode(i), CandleCode(i-1),
           perc
           );
}
FileClose(handle);
return(0);
}



int CandleCode(int g)
{
  int a, b, c, d, i = g;
  double sumx=0, sumy=0, sumz=0;
  double iOp, iCl;
  
  iOp = iOpen(Symbol(),P,i);
  iCl = iClose(Symbol(),P,i);
  if(iOp > iCl)
  {
   double hb0 = iOp;
   double lb0 = iCl;
  }
  else
  {
   hb0 = iCl;
   lb0 = iOp;
  } 

  for(int k=0; k<49; k++)
  {
   iOp = iOpen(Symbol(),P,k);
   iCl = iClose(Symbol(),P,k);
   if(iOp > iCl)
   {
    double hb = iOp;
    double lb = iCl;
   }
   else
   {
    hb = iCl;
    lb = iOp;
   } 
   double x = MathAbs(iCl - iOp);
   double y = iHigh(Symbol(),P,k) - hb;
   double z = lb - iLow(Symbol(),P,k);
   sumx+=x;
   sumy+=y;
   sumz+=z;
  }

  double bs=sumx/50;
  double us=sumy/50;
  double ls=sumz/50;

  double b0=bs-bs/8*7;
  double b1=bs-bs/4;
  double b2=bs+bs/4;
  double u0=us-us/8*7;
  double u1=us-us/4;
  double u2=us+us/4;
  double l0=ls-ls/8*7;
  double l1=ls-ls/4;
  double l2=ls+ls/4;

  iOp = iOpen(Symbol(),P, i);
  iCl = iClose(Symbol(),P,i);
  if(iOp < iCl) 
   a=64;
  else 
   a=0;
  if(hb0 == iCl)
  {
   if(MathAbs(iOp - iCl) < b0) 
    b = 0;
   if(
      MathAbs(iOp - iCl) < b1 
   && MathAbs(iOp - iCl) > b0
     ) 
    b = 16;
   if(
      MathAbs(iOp - iCl) > b1 
   && MathAbs(iOp - iCl) < b2
     ) 
    b = 32;
   if(MathAbs(iOp - iCl) > b2) 
    b =48;
  }
   
  if(hb0 == iOp)
  {
   if(MathAbs(iOp - iCl) < b0) 
    b = 48;
   if(
      MathAbs(iOp - iCl) < b1 
   && MathAbs(iOp - iCl) > b0
     ) 
    b = 32;
   if(
      MathAbs(iOp - iCl) > b1 
   && MathAbs(iOp - iCl) < b2
     ) 
    b = 16;
   if(MathAbs(iOp - iCl) > b2) 
    b =0;
  }

  if(iHigh(Symbol(),P,i) - hb0 < u0) c = 0;
  if(iHigh(Symbol(),P,i) - hb0 > u0 && iHigh(Symbol(),P,i) - hb0 < u1) c = 4;
  if(iHigh(Symbol(),P,i) - hb0 > u1 && iHigh(Symbol(),P,i) - hb0 < u2) c = 8;
  if(iHigh(Symbol(),P,i) - hb0 > u2) c = 12;

  if(lb0 - iLow(Symbol(),P,i) < l0) d = 3;
  if(lb0 - iLow(Symbol(),P,i) > l0 && lb0 - iLow(Symbol(),P,i) < l1) d = 2;
  if(lb0 - iLow(Symbol(),P,i) > l1 && lb0 - iLow(Symbol(),P,i) < l2) d = 1;
  if(lb0 - iLow(Symbol(),P,i) > l2) d = 0;

  return(a+b+c+d);
}


